﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace UltrawinGridDemo
{
    class EmployeeList
    {
        private int employeeId;
        private string employeeName;
        private int managerId;
        private string managerName;
        private List<EmployeeList> children;
        private Boolean isChild;          

        public string EmployeeName
        {
            get
            {
                return employeeName;
            }
            set
            {
                employeeName = value;
            }
        }        

        public string ManagerName
        {
            get
            {
                return managerName;
            }
            set
            {
                managerName = value;
            }
        }

        public int EmployeeId
        {
            get
            {
                return employeeId;
            }
            set
            {
                employeeId = value;
            }
        }

        public int ManagerId
        {
            get
            {
                return managerId;
            }
            set
            {
                managerId = value;
            }
        }

        public List<EmployeeList> Children
        {
            get
            {
                return children;
            }
            set
            {
                children = value;
            }
        }

        public EmployeeList(int empId,string empName,int mngrId, string mngrName)
        {
            this.EmployeeId=empId;
            this.EmployeeName =empName;
            this.ManagerId = mngrId;
            this.ManagerName =mngrName;
        }
        public static List<EmployeeList> GetEmployees(List<EmployeeList> allEmployees)
        {
            int i = 0;
            foreach (EmployeeList employee in allEmployees)
            {
                employee.Children = allEmployees.Where(e => e.ManagerId == employee.EmployeeId).ToList();
                for (i = 0; i < employee.Children.Count; i++)
                {
                    employee.Children[i].isChild = true;
                }
            }
            allEmployees.RemoveAll(removeChild);
           return allEmployees;

        }

        //public static List<EmployeeList> GetEmployees(List<EmployeeList> allEmployees)

        //    int i = 0;
        //    foreach (EmployeeList employee in allEmployees)
        //    {
        //        employee.Children = allEmployees.Where(e => e.ManagerId == employee.EmployeeId).ToList();
        //        for (i = 0; i < employee.Children.Count; i++)
        //        {
        //            employee.Children[i].isChild = true;
        //        }
        //    }
        //    allEmployees.RemoveAll(removeChild);
        //    return allEmployees;
        //}

        private static bool removeChild(EmployeeList emp)
        {
            if (emp.isChild == true)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

    }
}
